with open('equation.in', 'r') as fin:
    x, y, z, sumofnums = map(int, fin.readline().replace('\n', '').split())


nums = [x, y, z]
goodcomb = {}

for x1 in range(3):
    for y1 in range(3):
        for z1 in range(3):
            if x**(x1+1) + y**(y1+1) + z**(z1+1) == sumofnums:
                if (x1 == 2 or y1 == 2 or z1 == 2) and (x1 == 1 or y1 == 1 or z1 == 1) and (x1 == 0 or y1 == 0 or z1 == 0):
                    goodcomb[x1], goodcomb[y1], goodcomb[z1] = x, y, z
                    break

if goodcomb == {}:
    goodcomb[2], goodcomb[1], goodcomb[0] = -1, -1, -1


with open('equation.out', 'w') as fout:
    for i in range(2, -1, -1):
        fout.write(str(goodcomb[i])+' ')