#include <iostream>
#include <cstdio>
#include <algorithm>

using namespace std;

int main(){
    freopen("passat.in", "r", stdin);
    freopen("passat.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    pair<int, int> ad[n];
    for (int i = 0; i < n; ++ i) {
        int t, d;
        cin >> t >> d;
        ad[i] = pair<int, int>(d, t);
    }
    sort(ad, ad + n);
    int search_min[n];
    search_min[0] = ad[0].first - ad[0].second;
    int mini = search_min[0];
    for (int i = 1; i < n; ++ i) {
        search_min[i] = ad[i].first - (ad[i - 1].first - search_min[i - 1] +
                            ad[i].second);
        if (search_min[i] < mini) {
            mini = search_min[i];
        }
    }
    cout << mini << endl;
    return 0;
}
