#include <bits/stdc++.h>
#include <ext/rope>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_cxx;
using namespace __gnu_pbds;
using namespace std;

#define int long long
#define vi vector<int>
#define pb push_back
#define mp make_pair
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define SORT(a) sort(all(a))
#define F first
#define S second
#define inf (int)(1e18)
#define e 1e-7
#define ld long double
#define rng(n) for(int __ = 0; __ < (int)(n); __++)
#define rngi(i, n) for(int i = 0; i < (int)(n); i++)
#define sz(x) (int)(x.size())
#define problem "passat"

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template<typename T>
void print(T a, int add = 0, int szz = 0)
{
    if(szz)
        cout << sz(a) << '\n';
    for(auto x : a)
        cout << x + add << ' ' ;
    cout<<'\n';
}

signed main()
{
    if(1)
    {
        freopen(problem".in", "r", stdin);
        freopen(problem".out", "w", stdout);
    }
    srand(time(NULL));
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int n;
    cin >> n;
    vector<pii> a(n);
    for(auto &i : a)
        cin >> i.F >> i.S;
    auto can = [&](int x)
    {
        for(auto i : a)
            if(i.S < x)
                return 0LL;
        for(auto &i : a)
            i.S -= x;
        int res = 1;
        sort(all(a), [](const pii&f, const pii&s) {return f.S < s.S || (f.S == s.S && f.F < s.F);});
        int now = 0;
        for(auto i : a)
        {
            now += i.F;
            if(now > i.S)
                res = 0;
        }
        for(auto &i : a)
            i.S += x;
        return res;
    };
    int l = 0, r = 1e18;
    while(r- l > 1)
    {
        int m = l + r >> 1;
        if(can(m))
            l = m;
        else
            r = m;
    }
    int ans = l;
    if(can(r))
        ans = r;
    cout << ans << '\n';
    return 0;
}
