/* GCC */
#include <iostream>
#include <cstdio>
using namespace std;

long long intpow(long long base, long long exponent);
bool test(int a, int b, int c, int k);

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    freopen("equation.in", "r", stdin);
    freopen("equation.out", "w", stdout);

    int x, y, z, k;
    cin >> x >> y >> z >> k;
    if (test(x, y, z, k) || test(x, z, y, k) || test(y, x, z, k) || test(y, z, x, k) || test(z, x, y, k) || test(z, y, x, k)) return 0;
    cout << "-1 -1 -1\n";

    return 0;
}

long long intpow(long long base, long long exponent)
{
    long long result = 1;
    while (exponent--) result *= base;
    return result;
}
bool test(int a, int b, int c, int k)
{
    if (intpow(a, 3) + intpow(b, 2) + c == k) {
        cout << a << ' ' << b << ' ' << c << '\n';
        return true;
    }
    return 0;
}
