/* GCC */
#include <iostream>
#include <cstdio>
using namespace std;

bool substr_with_n_same_letters(const char *str, int length, int n);

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    freopen("game.in", "r", stdin);
    freopen("game.out", "w", stdout);

    int n, length;
    char str[2000001];

    bool one, two, three;
    one = two = three = false;

    cin >> n >> length >> str;

    if (substr_with_n_same_letters(str, length, 1)) one = true;
    if (substr_with_n_same_letters(str, length, 2)) two = true;
    if (substr_with_n_same_letters(str, length, 3)) three = true;

    //cout << one << ' ' << two << ' ' << three << '\n';

    if (three) {
        if (n % 3 == 1) {
            if (one) {
                cout << n / 3 + 1;
                return 0;
            }
            if (two && n >= 4) {
                cout << (n - 4) / 3 + 2;
                return 0;
            }
            cout << -1;
            return 0;
        }
        if (n % 3 == 2) {
            if (two) {
                cout << n / 3 + 1;
                return 0;
            }
            if (one) {
                cout << n / 3 + 2;
                return 0;
            }
            cout << -1;
            return 0;
        }
        cout << n / 3;
        return 0;
    }
    if (two) {
        if (n % 2) {
            if (one) {
                cout << n / 2 + 1;
                return 0;
            }
            cout << -1;
            return 0;
        }
        cout << n / 2;
        return 0;
    }
    if (one) {
        cout << n;
        return 0;
    }
    cout << -1;
    return 0;
}

bool substr_with_n_same_letters(const char *str, int length, int n)
{
    char curr, j;
    for (int i = 0; i < length; ++i) {
        curr = str[i];
        for (j = 1; i + j < length && str[i + j] == curr; ++j);
        if (j == n) return true;
        i += j - 1;
    }
    return false;
}
