#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

vector <bool> get_jump(string &s)
{
    vector<bool> a(3, false); // 0 . -   1 , 1 . -   2 , . .
    if (s.size() == 1)
        return { true, false, false };
    if (s.size() == 2)
    {
        if (s[0] == s[1]) return { false, true, false };
        return { true, false, false };
    }


    for (int k = 1; k <= 3; ++k)
    {
        for (int i = 0; i <= s.size() - k; ++i)
        {
            bool t = true;
            for (int ind = i; ind < k + i; ++ind)
            {
                if (s[ind] != s[i])
                {
                    t = false;
                    break;
                }
            }
            if (!t) continue;
            if ((s.size() == i + k || s[i + k] != s[i]) && (i == 0 || s[i - 1] != s[i]))
                a[k - 1] = true;
        }
    }
    return a;
}

int main()
{
    ifstream fin ("game.in");
    ofstream fout ("game.out");
    int n, k;
    string s;
    fin >> n >> k >> s;

    vector<bool> v = get_jump(s); // ,    
    int a = 0;
    if (v[0])
    {
        if (v[2])
        {
            a += n / 3;
            if (n % 3 == 2)
            {
                if (v[1]) ++a;
                else a += 2;
            }
            else if (n % 3 == 1) ++a;
        }
        else if (v[1])
        {
            a += n / 2;
            if (n % 2 == 1) ++a;
        }
        else a += n;
    }
    else if (v[1])
    {
        if (n % 2 == 0)
        {
            if (v[2])
            {
                k = n / 3;
                if (k % 2 == 0)
                {
                    a += k;
                    if (n % 3 == 2) ++a;
                }
                else a += k + 1;
            }
            else a += n / 2;
        }
        else if (v[2])
        {
            if (n % 3 == 0) a += n / 3;
            else a += n / 3 + 1;
        }
        else a = -1;
    }
    else if (v[2])
    {
        if (n % 3 == 0) a += n / 3;
        else a = -1;
    }
    else if (n != 0) a = -1;
    fout << a << endl;
    return 0;
}
