/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    freopen("passat.in", "r", stdin);
    freopen("passat.out", "w", stdout);
    int n;
    cin >> n;
    vector<pair<int, int> > pairs(n);
    for (int i = 0;i < n;i++) {
        cin >> pairs[i].first >> pairs[i].second;
    }

    sort(pairs.begin(), pairs.end(), [](const pair<int, int>& p1, const pair<int, int>& p2) -> bool {
        return p1.second > p2.second;
    });

    int day = pairs[0].second;
    for (int i = 0;i < n;i++) {
        if (day > pairs[i].second) {
            day = pairs[i].second - pairs[i].first;
        } else {
            day -= pairs[i].first;
        }
    }

    cout << day << endl;

    fclose(stdin);
    fclose(stdout);
    return 0;
}
