INPUT_FILE_PATH = 'equation.in'
OUTPUT_FILE_PATH = 'equation.out'
a = 0
b = 0
c = 0
k = 0

def main():
    load_file()

    combinations = get_all_combinations()
    matching_combinations = []
    result = ()
    
    for combination in combinations:
        if not combination[0] ** 3 + combination[1] ** 2 + combination[2] == k:
            continue
        matching_combinations.append(combination)

    if not matching_combinations:
        result = (-1, -1, -1)
    else:
        result = matching_combinations[0]
    # TODO: main function
    string_result = str(result[0]) + ' ' + str(result[1]) + ' ' + str(result[2])
    save_to_file(string_result)
    
    
def get_all_combinations():
    numbers = (a, b, c)
    index_combinations = []
    number_combinations = []
    
    for x in range(3):
        for y in range(3):
            for z in range(3):
                if x == y or x == z or y == z:
                    continue
                index_combinations.append((x, y, z))

    for combination in index_combinations:
        number_combination = (numbers[combination[0]], numbers[combination[1]], numbers[combination[2]])
        number_combinations.append(number_combination)
    
    return number_combinations

def load_file():
    global a, b, c, k
    f = open(INPUT_FILE_PATH, 'r')

    a, b, c, k = f.readline().split()
    a = int(a)
    b = int(b)
    c = int(c)
    k = int(k)
    
    f.close()

def save_to_file(data):
    f = open(OUTPUT_FILE_PATH, 'w')
    f.write(data)
    f.close()
    

if __name__ == '__main__':
    main()
