

with open('equation.in') as input_file:
	x, y, z, k = map(int, input_file.readline().split())

combinations = ((x, y, z), (x, z, y), (y, x, z), (y, z, x), (z, y, x), (z, x, y))

with open('equation.out', 'w') as output_file:
	for combination in combinations:
		if combination[0] ** 3 + combination[1] ** 2 + combination[2] == k:
			output_file.write(f'{combination[0]} {combination[1]} {combination[2]}')
			exit()

	output_file.write('-1 -1 -1')
